void ResolveSourceReq(basestring& ReqStr, int** ReqCode, int* CopyDep)
{
	int ReqIVal, ReqID;
	int num, len;
	char *ReqPos, *TempPos;
	char ReqTVal[SMALL_BUFFER_LEN];

	int* ByteCode;
	int ByteCodeSize;

	int j;

	ByteCode = (int*) mallocl(strlen(ReqStr) * sizeof(int), "ResolveSourceReq-ByteCode");
	ByteCodeSize = 0;

	ReqPos = ReqStr.buffer;
	while (*ReqPos)
	{
		ReqID = TwoCharToInt(ReqPos);
		ReqPos += 3;

		ByteCode[ByteCodeSize++] = ReqID;
		if (ReqID == TwoCharToInt("PR"))
		{
			ByteCode[ByteCodeSize++] = GetFeatNumber(ReqPos);
		}
		else if (ReqID == TwoCharToInt("PG"))
		{
			ByteCode[ByteCodeSize++] = GetFeatNumber(ReqPos);
			if (CopyDep && *CopyDep == -1)
			{
				*CopyDep = ByteCode[ByteCodeSize - 1];
			}
		}
		else if (ReqID == TwoCharToInt("HS"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("KR"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("GA"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("CL"))
		{
			num = substr_count('|', ReqPos) + 1;
			len = strlen(ReqPos);
			ByteCode[ByteCodeSize++] = num;
			TempPos = ReqPos;
			str_replace('|', 0, ReqPos, len);
			for (j = 0;j < num;j++)
			{
				sscanf(TempPos, "%s %d", ReqTVal, &ReqIVal);
				ByteCode[ByteCodeSize++] = GetCharNumber(ReqTVal);
				ByteCode[ByteCodeSize++] = ReqIVal;
				TempPos += strlen(TempPos) + 1;
			}
			str_replace(0, '|', ReqPos, len);
		}
		else if (ReqID == TwoCharToInt("ST"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("GE"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("KO"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("IN"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("WE"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("CH"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("RA"))
		{
			num = substr_count('|', ReqPos) + 1;
			ByteCode[ByteCodeSize++] = num;
			len = strlen(ReqPos);
			TempPos = ReqPos;
			str_replace('|', 0, ReqPos, len);
			for (j = 0;j < num;j++)
			{
				ByteCode[ByteCodeSize++] = GetRaceNumber(TempPos);
				TempPos += strlen(TempPos) + 1;
			}
			str_replace(0, '|', ReqPos, len);
		}
		else if (ReqID == TwoCharToInt("NC"))
		{
			ByteCode[ByteCodeSize++] = GetCharNumber(ReqPos);
		}
		else if (ReqID == TwoCharToInt("LV"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("SF"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("SW"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("SR"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("PF"))
		{
			ByteCode[ByteCodeSize++] = atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("MF"))
		{
			ByteCode[ByteCodeSize++] =  atoi(ReqPos);
		}
		else if (ReqID == TwoCharToInt("SN"))
		{
		}
		else if (ReqID == TwoCharToInt("DV"))
		{
		}
		else if (ReqID == TwoCharToInt("SP"))
		{
			ByteCode[ByteCodeSize++] = GetSpellNumber(ReqPos);
		}
		else if (ReqID == TwoCharToInt("SS"))
		{
		}
		else
		{
			printf("Unknown Feat Rule: %s\n", ReqPos - 3);
			quitprog();
		}
		ReqPos += strlen(ReqPos) + 1;
	}
	*ReqCode = (int*) mallocl((ByteCodeSize + 1) * sizeof(int), "ResolveSourceReq-ReqCode");
	(*ReqCode)[0] = ByteCodeSize;
	CopyMemory(&((*ReqCode)[1]), ByteCode, ByteCodeSize * sizeof(int));
	freel(ByteCode);
}

void ResolveSourceSkill(basestring& SkillStr, int** SkillCode)
{
	char* TempPos = SkillStr.buffer;
	int* ByteCode;
	int ByteCodeSize = 0;

	char* SkillName;
	int SkillLvl;

	ByteCode = (int*) mallocl(strlen(SkillStr) * sizeof(int), "ResolveSourceSkill-BytePos");

	while (*TempPos)
	{
		SkillName = (char*) mallocl(strlen(TempPos), "ResolveSourceSkill-SkillName");
		sscanf(TempPos, "%s %d", SkillName, &SkillLvl);
		ByteCode[ByteCodeSize++] = GetSkillNumber(SkillName);
		ByteCode[ByteCodeSize++] = SkillLvl;
		TempPos += strlen(TempPos) + 1;
		freel(SkillName);
	}

	*SkillCode = (int*) mallocl((ByteCodeSize + 1) * sizeof(int), "ResolveSourceSkill-SkillCode");
	(*SkillCode)[0] = ByteCodeSize;
	CopyMemory(&((*SkillCode)[1]), ByteCode, ByteCodeSize * sizeof(int));
	freel(ByteCode);
}

void ResolveSourceSkillboost(basestring& SkillStr, int** SkillCode)
{
	char* TempPos = SkillStr.buffer;
	int* ByteCode;
	int ByteCodeSize = 0;

	char* SkillName;
	char* BonusName;
	int SkillLvl;

	ByteCode = (int*) mallocl(strlen(SkillStr) * sizeof(int), "ResolveSourceSkillbonus-BytePos");

	while (*TempPos)
	{
		SkillName = (char*) mallocl(strlen(TempPos), "ResolveSourceSkill-SkillName");
		BonusName = (char*) mallocl(strlen(TempPos), "ResolveSourceSkill-BonusName");
		sscanf(TempPos, "%s %d", SkillName, &SkillLvl);
		if (strstr(SkillName, ":"))
		{
			str_replace(':', 0, SkillName);
			ByteCode[ByteCodeSize++] = GetSkillNumber(SkillName);
			ByteCode[ByteCodeSize++] = GetBonusNumber(SkillName + strlen(SkillName) + 1);
		}
		else
		{
			ByteCode[ByteCodeSize++] = GetSkillNumber(SkillName);
			ByteCode[ByteCodeSize++] = -1;
		}
		ByteCode[ByteCodeSize++] = SkillLvl;
		TempPos += strlen(TempPos) + 1;
		freel(SkillName);
		freel(BonusName);
	}

	*SkillCode = (int*) mallocl((ByteCodeSize + 1) * sizeof(int), "ResolveSourceSkillbonus-SkillCode");
	(*SkillCode)[0] = ByteCodeSize;
	CopyMemory(&((*SkillCode)[1]), ByteCode, ByteCodeSize * sizeof(int));
	freel(ByteCode);
}

void ResolveSourceSynergies(basestring& SkillStr, int** SkillCode)
{
	char* TempPos = SkillStr.buffer;
	int* ByteCode;
	int ByteCodeSize = 0;

	ByteCode = (int*) mallocl(strlen(SkillStr) * sizeof(int), "ResolveSourceSynergies-BytePos");

	while (*TempPos)
	{
		ByteCode[ByteCodeSize++] = GetSkillNumber(TempPos);
		TempPos += strlen(TempPos) + 1;
	}

	*SkillCode = (int*) mallocl((ByteCodeSize + 1) * sizeof(int), "ResolveSourceSynergies-SkillCode");
	(*SkillCode)[0] = ByteCodeSize;
	CopyMemory(&((*SkillCode)[1]), ByteCode, ByteCodeSize * sizeof(int));
	freel(ByteCode);
}


void ResolveSourceFeats(basestring& FeatStr, int** FeatCode)
{
	char* TempPos = FeatStr.buffer;
	int* ByteCode;
	int ByteCodeSize = 0;
	int j;

	ByteCode = (int*) mallocl(strlen(FeatStr) * sizeof(int), "ResolveSourceFeats-BytePos");

	while (*TempPos)
	{
		if (strstr(TempPos, "MIN_METAMAGIC") == TempPos)
		{
			sscanf(TempPos, "MIN_METAMAGIC:%d", &j);
			ByteCode[ByteCodeSize++] = -FEAT_TYPE_METAMAGIC;
			ByteCode[ByteCodeSize++] = j;
		}
		else if (strstr(TempPos, "MIN_FIGHTER") == TempPos)
		{
			sscanf(TempPos, "MIN_FIGHTER:%d", &j);
			ByteCode[ByteCodeSize++] = -FEAT_TYPE_FIGHTER;
			ByteCode[ByteCodeSize++] = j;
		}
		else if (strstr(TempPos, "MIN_METAPSIONIC") == TempPos)
		{
			sscanf(TempPos, "MIN_METAPSIONIC:%d", &j);
			ByteCode[ByteCodeSize++] = -FEAT_TYPE_PSIONIC;
			ByteCode[ByteCodeSize++] = j;
		}
		else if (strstr(TempPos, "MIN_DIVINE") == TempPos)
		{
			sscanf(TempPos, "MIN_DIVINE:%d", &j);
			ByteCode[ByteCodeSize++] = -FEAT_TYPE_DIVINE;
			ByteCode[ByteCodeSize++] = j;
		}
		else
		{
			ByteCode[ByteCodeSize++] = GetFeatNumber(TempPos);
		}
		TempPos += strlen(TempPos) + 1;
	}

	*FeatCode = (int*) mallocl((ByteCodeSize + 1) * sizeof(int), "ResolveSourceFeats-FeatCode");
	(*FeatCode)[0] = ByteCodeSize;
	CopyMemory(&((*FeatCode)[1]), ByteCode, ByteCodeSize * sizeof(int));
	freel(ByteCode);
}


int ResolveSource()
{
	int i;

	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		Source.FeatSource[i].CopyDepFrom = -1;
		ResolveSourceReq(TempSource.FeatSource[i].ReqStr, &Source.FeatSource[i].ReqCode.ptr, &Source.FeatSource[i].CopyDepFrom);
		ResolveSourceSkill(TempSource.FeatSource[i].SkillStr, &Source.FeatSource[i].SkillCode.ptr);
	}
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		ResolveSourceReq(TempSource.CharSource[i].ReqStr, &Source.CharSource[i].ReqCode.ptr, NULL);
		ResolveSourceSkill(TempSource.CharSource[i].SkillStr, &Source.CharSource[i].SkillCode.ptr);
		ResolveSourceFeats(TempSource.CharSource[i].FeatStr, &Source.CharSource[i].FeatCode.ptr);
		Source.CharSource[i].AttachClassNum = (TempSource.CharSource[i].AttachClass[0] == ';' ? -1 : GetCharNumber(TempSource.CharSource[i].AttachClass));
		Source.CharSource[i].ForceWeaponNum = (TempSource.CharSource[i].ForceWeapon[0] == ';' ? -1 : GetEquipNumber(TempSource.CharSource[i].ForceWeapon));
	}
	for (i = 0;i < Source.EffectSourceCount;i++)
	{
		ResolveSourceSkillboost(TempSource.EffectSource[i].SkillBoost, &Source.EffectSource[i].SkillCode.ptr);
	}
	for (i = 0;i < Source.SpecificSourceCount;i++)
	{
		ResolveSourceSkillboost(TempSource.SpecificSource[i].SkillBoost, &Source.SpecificSource[i].SkillCode.ptr);
	}
	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		ResolveSourceSynergies(TempSource.SkillSource[i].Synergy, &Source.SkillSource[i].SynCode.ptr);
	}
	for (i = 0;i < Source.RaceSourceCount;i++)
	{
		Source.RaceSource[i].SubRaceBin = (TempSource.RaceSource[i].SubRace.buffer[0] == ';' ? -1 : GetRaceNumber(TempSource.RaceSource[i].SubRace));
	}
	return(0);
}

int SourceInit()
{
	int tmp;

	if (SourceInitDone)
	{
		return(0);
	}

	ZeroMemory(&Source, sizeof(clsSource));
	Source.lpSymbolStart = bnf::SymbolNames;

	if (SourceInit<clsDomainSource, clsSourceFake>(DOMAIN_FILE, &Source.DomainSource, NULL, &Source.DomainSourceCount, &SetDomainSource)) {return(1);}
	if (SourceInit<clsMonsterTypeSource, clsSourceFake>(MONSTER_TYPE_FILE, &Source.MonsterTypeSource, NULL, &Source.MonsterTypeSourceCount, &SetMonsterTypeSource)) {return(1);}
	if (SourceInit<clsRegionSource, clsSourceFake>(REGION_FILE, &Source.RegionSource, NULL, &Source.RegionSourceCount, &SetRegionSource)) {return(1);}
	if (SourceInit<clsSchoolSource, clsSourceFake>(SCHOOL_FILE, &Source.SchoolSource, NULL, &Source.SchoolSourceCount, &SetSchoolSource)) {return(1);}
	if (SourceInit<clsSizeSource, clsSourceFake>(SIZE_FILE, &Source.SizeSource, NULL, &Source.SizeSourceCount, &SetSizeSource)) {return(1);}
	if (SourceInit<clsTemplateSource, clsSourceFake>(TEMPLATE_FILE, &Source.TemplateSource, NULL, &Source.TemplateSourceCount, &SetTemplateSource)) {return(1);}
	if (SourceInit<clsSpecialSource, clsSourceFake>(SPECIAL_FILE, &Source.SpecialSource, NULL, &Source.SpecialSourceCount, &SetSpecialSource)) {return(1);}
	if (SourceInit<clsBonusSource, clsSourceFake>(BONUS_FILE, &Source.BonusSource, NULL, &Source.BonusSourceCount, &SetBonusSource)) {return(1);}

	Source.AttributeNames[0] = "Strke";
	Source.AttributeNames[1] = "Geschicklichkeit";
	Source.AttributeNames[2] = "Konstitution";
	Source.AttributeNames[3] = "Intelligenz";
	Source.AttributeNames[4] = "Weisheit";
	Source.AttributeNames[5] = "Charisma";

	if (SourceInit<clsCharSource, clsTempCharSource>(CHAR_FILE, &Source.CharSource, &TempSource.CharSource, &Source.CharSourceCount, &SetCharSource)) {return(1);}
	ClassPosition = (int*) mallocl(Source.CharSourceCount * sizeof(int), "SourceInit-ClassPositions");
	if (SourceInit<clsRaceSource, clsTempRaceSource>(RACE_FILE, &Source.RaceSource, &TempSource.RaceSource, &Source.RaceSourceCount, &SetRaceSource, 1)) {return(1);}
	RacePosition = (int*) mallocl(Source.RaceSourceCount * sizeof(int), "SourceInit-RacePositions");
	if (SourceInit<clsFeatSource, clsTempFeatSource>(FEAT_FILE, &Source.FeatSource, &TempSource.FeatSource, &Source.FeatSourceCount, &SetFeatSource)) {return(1);}
	if (SourceInit<clsSkillSource, clsTempSkillSource>(SKILL_FILE, &Source.SkillSource, &TempSource.SkillSource, &Source.SkillSourceCount, &SetSkillSource)) {return(1);}
	
	if (SourceInit<clsSpellSource, clsSourceFake>(SPELL_FILE, &Source.SpellSource, NULL, &Source.SpellSourceCount, &SetSpellSource)) {return(1);}
	if (SourceInit<clsSourceFake, clsSourceFake>(SPELL_FILE_2, NULL, NULL, &tmp, &SetSpellSource2, 0, true)) {return(1);}
	CopySpellList();

	if (SourceInit<clsPowerSource, clsSourceFake>(POWER_FILE, &Source.PowerSource, NULL, &Source.PowerSourceCount, &SetPowerSource)) {return(1);}
	if (SourceInit<clsEffectSource, clsTempEffectSource>(EFFECT_FILE, &Source.EffectSource, &TempSource.EffectSource, &Source.EffectSourceCount, &SetEffectSource)) {return(1);}
	if (SourceInit<clsMonsterSource, clsSourceFake>(MONSTER_FILE, &Source.MonsterSource, NULL, &Source.MonsterSourceCount, &SetMonsterSource)) {return(1);}
	DetermineCR(0, 0, 0, NULL, 0, 1);

	if (SourceInit<clsEquipSource, clsSourceFake>(EQUIP_FILE, &Source.EquipSource, NULL, &Source.EquipSourceCount, &SetEquipSource)) {return(1);}
	for (tmp = 0;tmp < Source.EquipSourceCount;tmp++)
	{
		Source.EquipSource[tmp].Probability = Source.EquipSource[tmp].RaceProbability = 0;
	}
	if (SourceInit<clsSourceFake, clsSourceFake>(W_PROB_FILE, NULL, NULL, &tmp, &SetWProbSource, 0, true)) {return(1);}

	if (SourceInit<clsSpecificSource, clsTempSpecificSource>(SPECIFIC_FILE, &Source.SpecificSource, &TempSource.SpecificSource, &Source.SpecificSourceCount, &SetSpecificSource)) {return(1);}

	if (ProfileSourceInit() == 1) {return(1);}

	Source.RaceSource[Source.RaceSourceCount].Name = "Monster";
	Source.RaceSource[Source.RaceSourceCount].PreferedAttackType = 1;
	Source.RaceSource[Source.RaceSourceCount].Probability = 0;
	Source.RaceSource[Source.RaceSourceCount].Size = 0;

	FillArrayFromFile(START_MONEY_FILE, Source.StartMoney, 100);
	FillArrayFromFile(TREASURE_FILE, Source.Treasure, 100);

	InitMonsterDesc();

	if (ResolveSource()) {return(1);}
	delete[] TempSource.CharSource;
	delete[] TempSource.FeatSource;
	delete[] TempSource.SkillSource;
	delete[] TempSource.RaceSource;
	delete[] TempSource.EffectSource;
	delete[] TempSource.SpecificSource;

	OptimizeScript2();

	freel(ClassPosition);
	freel(RacePosition);
	SourceInitDone = true;

	return(0);
}

void SourceExit()
{
	int i;

	if (SourceInitDone)
	{
		printf("Freeing Source Data:");
		printf("Chars, ");CharSourceExit();
		printf("Races, ");RaceSourceExit();
		printf("Feats, ");FeatSourceExit();
		printf("Equipment, ");EquipSourceExit();
		printf("Skills, ");SkillSourceExit();
		printf("Spells, ");SpellSourceExit();
		printf("Powers, ");PowerSourceExit();
		printf("Effects, ");EffectSourceExit();
		printf("Monsters, ");MonsterSourceExit();
		printf("Specific, ");SpecificSourceExit();

		printf("Domains, ");DomainSourceExit();
		printf("MonsterTypes, ");MonsterTypeSourceExit();
		printf("Regions, ");RegionSourceExit();
		printf("Schools, ");SchoolSourceExit();
		printf("Size, ");SizeSourceExit();
		printf("Specials, ");SpecialSourceExit();
		printf("Templates, ");TemplateSourceExit();
		printf("Bonuses, ");BonusSourceExit();
		
		printf("Profiles\n");ProfileSourceExit();
	}

	for (i = 0;i < 6;i++)
	{
		Source.AttributeNames[i].~string();
	}

	SourceInitDone = false;
}
