template <class T> inline int GetSourceNumber(T* Source, int Count, const char* Name, int uncomplete = 0, int raiseerror = 1)
{
	int i;
	for (i = 0;i < Count;i++)
	{
		if (Source[i].Name == Name || (uncomplete && strstr(Source[i].Name, Name)))
		{
			return(i);
		}
	}
	if (raiseerror)
	{
		printf("Not found: %s\n", Name);
		quitprog();
		return(0);
	}
	else
	{
		return(-1);
	}
}

int GetCharNumber(const char* CharName)
{
	return(GetSourceNumber<clsCharSource>(Source.CharSource, Source.CharSourceCount, CharName));
}

int GetDomainNumber(const char* DomainName)
{
	return(GetSourceNumber<clsDomainSource>(Source.DomainSource, Source.DomainSourceCount, DomainName));
}

int GetEffectNumber(const char* EffectName)
{
	return(GetSourceNumber<clsEffectSource>(Source.EffectSource, Source.EffectSourceCount, EffectName));
}

int GetEquipNumber(const char* EquipName)
{
	return(GetSourceNumber<clsEquipSource>(Source.EquipSource, Source.EquipSourceCount, EquipName));
}

int GetFeatNumber(const char* FeatName, int uncomplete)
{
	return(GetSourceNumber<clsFeatSource>(Source.FeatSource, Source.FeatSourceCount, FeatName, uncomplete));
}

int GetMonsterNumber(const char* MonsterName)
{
	return(GetSourceNumber<clsMonsterSource>(Source.MonsterSource, Source.MonsterSourceCount, MonsterName));
}

int GetMonsterTypeNumber(const char* MonsterTypeName)
{
	return(GetSourceNumber<clsMonsterTypeSource>(Source.MonsterTypeSource, Source.MonsterTypeSourceCount, MonsterTypeName, 1));
}

int GetPowerNumber(const char* PowerName)
{
	return(GetSourceNumber<clsPowerSource>(Source.PowerSource, Source.PowerSourceCount, PowerName));
}

int GetRaceNumber(const char* RaceName)
{
	return(GetSourceNumber<clsRaceSource>(Source.RaceSource, Source.RaceSourceCount, RaceName));
}

int GetRegionNumber(const char* RegionName)
{
	return(GetSourceNumber<clsRegionSource>(Source.RegionSource, Source.RegionSourceCount, RegionName));
}

int GetSchoolNumber(const char* SchoolName)
{
	return(GetSourceNumber<clsSchoolSource>(Source.SchoolSource, Source.SchoolSourceCount, SchoolName));
}

int GetSizeNumber(const char* SizeName)
{
	return(GetSourceNumber<clsSizeSource>(Source.SizeSource, Source.SizeSourceCount, SizeName, 1));
}

int GetSkillNumber(const char* SkillName, int uncomplete)
{
	return(GetSourceNumber<clsSkillSource>(Source.SkillSource, Source.SkillSourceCount, SkillName, uncomplete));
}

int GetSpellNumber(const char* SpellName)
{
	return(GetSourceNumber<clsSpellSource>(Source.SpellSource, Source.SpellSourceCount, SpellName));
}

int GetSpecialNumber(const char* SpecialName, int type = -1)
{
	int i;
	for (i = 0;i < Source.SpecialSourceCount;i++)
	{
		if ((type == -1 || type == Source.SpecialSource[i].Type) && Source.SpecialSource[i].Name == SpecialName)
		{
			return(i);
		}
	}
	printf("Special not found(%s)\n", SpecialName);
	quitprog();
	return(0);
}

int GetTemplateNumber(const char* TemplateName)
{
	return(GetSourceNumber<clsTemplateSource>(Source.TemplateSource, Source.TemplateSourceCount, TemplateName));
}

int GetBonusNumber(const char* BonusName)
{
	return(GetSourceNumber<clsBonusSource>(Source.BonusSource, Source.BonusSourceCount, BonusName));
}
